// WhatVersionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WhatVersion.h"
#include "WhatVersionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWhatVersionDlg dialog

CWhatVersionDlg::CWhatVersionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWhatVersionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWhatVersionDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWhatVersionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWhatVersionDlg)
	DDX_Control(pDX, IDC_VERSION, m_Version);
	DDX_Control(pDX, IDOK, m_Ok);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWhatVersionDlg, CDialog)
	//{{AFX_MSG_MAP(CWhatVersionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWhatVersionDlg message handlers

BOOL CWhatVersionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	OSVERSIONINFO vi;
	vi.dwOSVersionInfoSize = sizeof(vi);
	GetVersionEx( &vi );
	CString Full, Version;
	TCHAR *Platform = "Unknown";
	
	if( vi.dwPlatformId == VER_PLATFORM_WIN32s )
		Platform = "Win32s on Windows 3.11";
	else
	if( vi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS )
	{
		if( vi.dwMinorVersion )
			Platform = _T("Windows 95");
		else
			Platform = _T("Windows 98");
	}
	else
	{
		if( vi.dwPlatformId == VER_PLATFORM_WIN32_NT )
		{
			if( vi.dwMajorVersion == 3 || vi.dwMajorVersion == 4 )
			{
				Platform = _T("Windows NT");
				Version.Format( _T("%d.%d"), vi.dwMajorVersion, vi.dwMinorVersion );
			}
			else
			if( vi.dwMajorVersion == 5 )
				Platform = _T("Windows 2000");
		}
	}

	Full.Format( _T("%s %s %s"), Platform, (LPCSTR)Version, vi.szCSDVersion );
	SetDlgItemText( IDC_VERSION, Full );

	m_ToolTips.Create( this );
	m_ToolTips.ModifyStyle( 0, TTS_BALLOON  );
	GetDlgItem(IDC_VERSION)->EnableToolTips( TRUE );
	GetDlgItem(IDOK)->EnableToolTips( TRUE );

	m_ToolTips.AddTool( &m_Version, "Version information" );
	m_ToolTips.AddTool( &m_Ok, "Click to Close" );
	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWhatVersionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWhatVersionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWhatVersionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CWhatVersionDlg::PreTranslateMessage(MSG* pMsg) 
{
	m_ToolTips.RelayEvent( pMsg );
	
	return CDialog::PreTranslateMessage(pMsg);
}
